<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Exercises.ItemWithAnswer</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#getItem"><span class="hs-identifier">getItem</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#getAnswer"><span class="hs-identifier">getAnswer</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>    </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#addSimpleGaps"><span class="hs-identifier">addSimpleGaps</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-6"></span><span>    </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier">mainVerbHint</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-7"></span><span>    </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier">possessiveHint</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#Hint"><span class="hs-identifier">Hint</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-10"></span><span class="hs-keyword">where</span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Either</span></span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.html"><span class="hs-identifier">Features</span></a></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-15"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Morphology.Inflection.html"><span class="hs-identifier">Morphology.Inflection</span></a></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Morphology.NominalForms.html"><span class="hs-identifier">Morphology.NominalForms</span></a></span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Syntax.html"><span class="hs-identifier">Syntax</span></a></span><span>
</span><span id="line-18"></span><span>
</span><span id="line-19"></span><span class="hs-comment">-- | An item with answer is a tuple that contains:</span><span>
</span><span id="line-20"></span><span class="hs-comment">--</span><span>
</span><span id="line-21"></span><span class="hs-comment">-- * a sentential 'Constituent' representing the item, and</span><span>
</span><span id="line-22"></span><span class="hs-comment">--</span><span>
</span><span id="line-23"></span><span class="hs-comment">-- * some extra information regarding the answer (parametric argument)</span><span>
</span><span id="line-24"></span><span class="hs-keyword">newtype</span><span> </span><span id="ItemWithAnswer"><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-var">ItemWithAnswer</span></a></span></span><span> </span><span id="local-6989586621679083299"><span class="annot"><a href="#local-6989586621679083299"><span class="hs-identifier hs-type">a</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="ItemWithAnswer"><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-var">ItemWithAnswer</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="#local-6989586621679083299"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679083261"><span id="local-6989586621679083263"><span id="local-6989586621679083265"><span class="annot"><span class="annottext">Int -&gt; ItemWithAnswer a -&gt; ShowS
[ItemWithAnswer a] -&gt; ShowS
ItemWithAnswer a -&gt; String
(Int -&gt; ItemWithAnswer a -&gt; ShowS)
-&gt; (ItemWithAnswer a -&gt; String)
-&gt; ([ItemWithAnswer a] -&gt; ShowS)
-&gt; Show (ItemWithAnswer a)
forall a. Show a =&gt; Int -&gt; ItemWithAnswer a -&gt; ShowS
forall a. Show a =&gt; [ItemWithAnswer a] -&gt; ShowS
forall a. Show a =&gt; ItemWithAnswer a -&gt; String
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [ItemWithAnswer a] -&gt; ShowS
$cshowList :: forall a. Show a =&gt; [ItemWithAnswer a] -&gt; ShowS
show :: ItemWithAnswer a -&gt; String
$cshow :: forall a. Show a =&gt; ItemWithAnswer a -&gt; String
showsPrec :: Int -&gt; ItemWithAnswer a -&gt; ShowS
$cshowsPrec :: forall a. Show a =&gt; Int -&gt; ItemWithAnswer a -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-26"></span><span>
</span><span id="line-27"></span><span id="local-6989586621679083295"><span class="annot"><a href="Exercises.ItemWithAnswer.html#getItem"><span class="hs-identifier hs-type">getItem</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-type">ItemWithAnswer</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679083295"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span></span><span>
</span><span id="line-28"></span><span id="getItem"><span class="annot"><span class="annottext">getItem :: ItemWithAnswer a -&gt; Constituent
</span><a href="Exercises.ItemWithAnswer.html#getItem"><span class="hs-identifier hs-var hs-var">getItem</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-type">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span id="local-6989586621679083259"><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083259"><span class="hs-identifier hs-var">a</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679083258"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679083258"><span class="hs-identifier hs-var">s</span></a></span></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083259"><span class="hs-identifier hs-var">a</span></a></span><span>
</span><span id="line-29"></span><span>
</span><span id="line-30"></span><span id="local-6989586621679083291"><span class="annot"><a href="Exercises.ItemWithAnswer.html#getAnswer"><span class="hs-identifier hs-type">getAnswer</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-type">ItemWithAnswer</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679083291"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679083291"><span class="hs-identifier hs-type">a</span></a></span></span><span>
</span><span id="line-31"></span><span id="getAnswer"><span class="annot"><span class="annottext">getAnswer :: ItemWithAnswer a -&gt; a
</span><a href="Exercises.ItemWithAnswer.html#getAnswer"><span class="hs-identifier hs-var hs-var">getAnswer</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-type">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span id="local-6989586621679083257"><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083257"><span class="hs-identifier hs-var">a</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679083256"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679083256"><span class="hs-identifier hs-var">s</span></a></span></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679083256"><span class="hs-identifier hs-var">s</span></a></span><span>
</span><span id="line-32"></span><span>
</span><span id="line-33"></span><span class="hs-comment">-- | Given a 'Tag' and a 'Constituent', generate an 'ItemWithAnswer'</span><span>
</span><span id="line-34"></span><span class="hs-comment">-- with the corresponding gapped version</span><span>
</span><span id="line-35"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#addSimpleGaps"><span class="hs-identifier hs-type">addSimpleGaps</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-type">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-36"></span><span id="addSimpleGaps"><span class="annot"><span class="annottext">addSimpleGaps :: String -&gt; Constituent -&gt; ItemWithAnswer [Maybe Constituent]
</span><a href="Exercises.ItemWithAnswer.html#addSimpleGaps"><span class="hs-identifier hs-var hs-var">addSimpleGaps</span></a></span></span><span> </span><span id="local-6989586621679083254"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679083254"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679083252"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083252"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span id="local-6989586621679083251"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083251"><span class="hs-identifier hs-var">lexis</span></a></span></span><span class="hs-special">)</span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679083254"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083252"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Constituent, [Maybe Constituent])
-&gt; ItemWithAnswer [Maybe Constituent]
forall a. (Constituent, a) -&gt; ItemWithAnswer a
</span><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-var">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Constituent -&gt; Constituent
</span><a href="Exercises.ItemWithAnswer.html#createGap"><span class="hs-identifier hs-var">createGap</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String] -&gt; Lexis -&gt; Constituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083252"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083251"><span class="hs-identifier hs-var">lexis</span></a></span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Constituent -&gt; Maybe Constituent
forall a. a -&gt; Maybe a
</span><span class="hs-identifier hs-var">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String] -&gt; Lexis -&gt; Constituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083252"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083251"><span class="hs-identifier hs-var">lexis</span></a></span><span class="hs-special">)</span><span class="hs-special">]</span><span class="hs-special">)</span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Constituent, [Maybe Constituent])
-&gt; ItemWithAnswer [Maybe Constituent]
forall a. (Constituent, a) -&gt; ItemWithAnswer a
</span><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-var">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[String] -&gt; Lexis -&gt; Constituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083252"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083251"><span class="hs-identifier hs-var">lexis</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Maybe Constituent
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span class="hs-special">]</span><span class="hs-special">)</span><span>
</span><span id="line-39"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#addSimpleGaps"><span class="hs-identifier hs-var">addSimpleGaps</span></a></span><span> </span><span id="local-6989586621679083248"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679083248"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span id="local-6989586621679083247"><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083247"><span class="hs-identifier hs-var">c</span></a></span></span><span>
</span><span id="line-40"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679083248"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; Bool
forall (t :: * -&gt; *) a. (Foldable t, Eq a) =&gt; a -&gt; t a -&gt; Bool
</span><span class="hs-operator hs-var">`elem`</span></span><span> </span><span class="annot"><span class="annottext">Constituent -&gt; [String]
</span><a href="Syntax.Constituent.html#getTags"><span class="hs-identifier hs-var">getTags</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083247"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Constituent, [Maybe Constituent])
-&gt; ItemWithAnswer [Maybe Constituent]
forall a. (Constituent, a) -&gt; ItemWithAnswer a
</span><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-var">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Constituent -&gt; Constituent
</span><a href="Exercises.ItemWithAnswer.html#createGap"><span class="hs-identifier hs-var">createGap</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083247"><span class="hs-identifier hs-var">c</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Constituent -&gt; Maybe Constituent
forall a. a -&gt; Maybe a
</span><span class="hs-identifier hs-var">Just</span></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083247"><span class="hs-identifier hs-var">c</span></a></span><span class="hs-special">]</span><span class="hs-special">)</span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Constituent, [Maybe Constituent])
-&gt; ItemWithAnswer [Maybe Constituent]
forall a. (Constituent, a) -&gt; ItemWithAnswer a
</span><a href="Exercises.ItemWithAnswer.html#ItemWithAnswer"><span class="hs-identifier hs-var">ItemWithAnswer</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Constituent -&gt; [Constituent] -&gt; Constituent
</span><a href="Syntax.Constituent.html#setConstituents"><span class="hs-identifier hs-var">setConstituents</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083247"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">[Constituent]
</span><a href="#local-6989586621679083244"><span class="hs-identifier hs-var">constituents</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083243"><span class="hs-identifier hs-var">answer</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-43"></span><span>    </span><span id="local-6989586621679083242"><span class="annot"><span class="annottext">subitems :: [ItemWithAnswer [Maybe Constituent]]
</span><a href="#local-6989586621679083242"><span class="hs-identifier hs-var hs-var">subitems</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(Constituent -&gt; ItemWithAnswer [Maybe Constituent])
-&gt; [Constituent] -&gt; [ItemWithAnswer [Maybe Constituent]]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">String -&gt; Constituent -&gt; ItemWithAnswer [Maybe Constituent]
</span><a href="Exercises.ItemWithAnswer.html#addSimpleGaps"><span class="hs-identifier hs-var">addSimpleGaps</span></a></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679083248"><span class="hs-identifier hs-var">tag</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Constituent -&gt; [Constituent]
</span><a href="Syntax.Constituent.html#getConstituents"><span class="hs-identifier hs-var">getConstituents</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083247"><span class="hs-identifier hs-var">c</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-44"></span><span>    </span><span id="local-6989586621679083244"><span class="annot"><span class="annottext">constituents :: [Constituent]
</span><a href="#local-6989586621679083244"><span class="hs-identifier hs-var hs-var">constituents</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ItemWithAnswer [Maybe Constituent] -&gt; Constituent)
-&gt; [ItemWithAnswer [Maybe Constituent]] -&gt; [Constituent]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="annot"><span class="annottext">ItemWithAnswer [Maybe Constituent] -&gt; Constituent
forall a. ItemWithAnswer a -&gt; Constituent
</span><a href="Exercises.ItemWithAnswer.html#getItem"><span class="hs-identifier hs-var">getItem</span></a></span><span> </span><span class="annot"><span class="annottext">[ItemWithAnswer [Maybe Constituent]]
</span><a href="#local-6989586621679083242"><span class="hs-identifier hs-var">subitems</span></a></span><span>
</span><span id="line-45"></span><span>    </span><span id="local-6989586621679083243"><span class="annot"><span class="annottext">answer :: [Maybe Constituent]
</span><a href="#local-6989586621679083243"><span class="hs-identifier hs-var hs-var">answer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ItemWithAnswer [Maybe Constituent] -&gt; [Maybe Constituent])
-&gt; [ItemWithAnswer [Maybe Constituent]] -&gt; [Maybe Constituent]
forall (t :: * -&gt; *) a b. Foldable t =&gt; (a -&gt; [b]) -&gt; t a -&gt; [b]
</span><span class="hs-identifier hs-var">concatMap</span></span><span> </span><span class="annot"><span class="annottext">ItemWithAnswer [Maybe Constituent] -&gt; [Maybe Constituent]
forall a. ItemWithAnswer a -&gt; a
</span><a href="Exercises.ItemWithAnswer.html#getAnswer"><span class="hs-identifier hs-var">getAnswer</span></a></span><span> </span><span class="annot"><span class="annottext">[ItemWithAnswer [Maybe Constituent]]
</span><a href="#local-6989586621679083242"><span class="hs-identifier hs-var">subitems</span></a></span><span>
</span><span id="line-46"></span><span>
</span><span id="line-47"></span><span class="hs-comment">-- | A function to generate a hint to accompany an item</span><span>
</span><span id="line-48"></span><span class="hs-keyword">type</span><span> </span><span id="Hint"><span class="annot"><a href="Exercises.ItemWithAnswer.html#Hint"><span class="hs-identifier hs-var">Hint</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-49"></span><span>
</span><span id="line-50"></span><span class="hs-comment">-- | Hint to show along with the item that indicates which verb</span><span>
</span><span id="line-51"></span><span class="hs-comment">-- should be conjugated</span><span>
</span><span id="line-52"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier hs-type">mainVerbHint</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#Hint"><span class="hs-identifier hs-type">Hint</span></a></span><span>
</span><span id="line-53"></span><span id="mainVerbHint"><span class="annot"><span class="annottext">mainVerbHint :: Hint
</span><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier hs-var hs-var">mainVerbHint</span></a></span></span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ShowS
forall a. HasCallStack =&gt; String -&gt; a
</span><span class="hs-identifier hs-var">error</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Could not find main verb in gap list&quot;</span></span><span>
</span><span id="line-54"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier hs-var">mainVerbHint</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679083238"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083238"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.html#V"><span class="hs-identifier hs-type">V</span></a></span><span> </span><span id="local-6989586621679083236"><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679083236"><span class="hs-identifier hs-var">verb</span></a></span></span><span> </span><span class="annot"><span class="annottext">VF
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679083235"><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083235"><span class="hs-identifier hs-var">xs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-55"></span><span>  </span><span class="hs-keyword">if</span><span> </span><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083238"><span class="hs-identifier hs-var">tags</span></a></span><span> </span><span class="annot"><span class="annottext">[String] -&gt; [String] -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;mainVerb&quot;</span></span><span class="hs-special">]</span><span>
</span><span id="line-56"></span><span>    </span><span class="hs-keyword">then</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot; (&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">Verb -&gt; String
</span><a href="Lexis.Verb.html#getVerb"><span class="hs-identifier hs-var">getVerb</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679083236"><span class="hs-identifier hs-var">verb</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;)&quot;</span></span><span>
</span><span id="line-57"></span><span>    </span><span class="hs-keyword">else</span><span> </span><span class="annot"><span class="annottext">Hint
</span><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier hs-var">mainVerbHint</span></a></span><span> </span><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083235"><span class="hs-identifier hs-var">xs</span></a></span><span>
</span><span id="line-58"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier hs-var">mainVerbHint</span></a></span><span> </span><span class="hs-special">(</span><span id="local-6989586621679083233"><span class="annot"><span class="annottext">Maybe Constituent
</span><a href="#local-6989586621679083233"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679083232"><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083232"><span class="hs-identifier hs-var">xs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Hint
</span><a href="Exercises.ItemWithAnswer.html#mainVerbHint"><span class="hs-identifier hs-var">mainVerbHint</span></a></span><span> </span><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083232"><span class="hs-identifier hs-var">xs</span></a></span><span>
</span><span id="line-59"></span><span>
</span><span id="line-60"></span><span class="hs-comment">-- | Hint to show along with the item that indicates</span><span>
</span><span id="line-61"></span><span class="hs-comment">-- the noun that should be inflected with genitive case</span><span>
</span><span id="line-62"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier hs-type">possessiveHint</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Exercises.ItemWithAnswer.html#Hint"><span class="hs-identifier hs-type">Hint</span></a></span><span>
</span><span id="line-63"></span><span id="possessiveHint"><span class="annot"><span class="annottext">possessiveHint :: Hint
</span><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier hs-var hs-var">possessiveHint</span></a></span></span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ShowS
forall a. HasCallStack =&gt; String -&gt; a
</span><span class="hs-identifier hs-var">error</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Could not find noun in gap list&quot;</span></span><span>
</span><span id="line-64"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier hs-var">possessiveHint</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679083231"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083231"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.html#N"><span class="hs-identifier hs-type">N</span></a></span><span> </span><span class="annot"><span class="annottext">Nominal
</span><a href="Lexis.Noun.html#Pronoun"><span class="hs-identifier hs-var">Pronoun</span></a></span><span> </span><span id="local-6989586621679083228"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083228"><span class="hs-identifier hs-var">nf</span></a></span></span><span class="hs-special">)</span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679083227"><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083227"><span class="hs-identifier hs-var">xs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-65"></span><span>  </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot; (&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">Person -&gt; Number -&gt; String
</span><a href="Morphology.NominalForms.html#basePronominalForms"><span class="hs-identifier hs-var">basePronominalForms</span></a></span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679083225"><span class="hs-identifier hs-var">pers</span></a></span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679083224"><span class="hs-identifier hs-var">num</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;)&quot;</span></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-67"></span><span>    </span><span class="hs-special">(</span><span id="local-6989586621679083225"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679083225"><span class="hs-identifier hs-var">pers</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679083224"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679083224"><span class="hs-identifier hs-var">num</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Case
</span><a href="Features.Nominal.html#grammCase"><span class="hs-identifier hs-var hs-var">grammCase</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083228"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-68"></span><span>      </span><span class="hs-special">(</span><span class="annot"><a href="Features.Nominal.html#Genitive"><span class="hs-identifier hs-type">Genitive</span></a></span><span> </span><span id="local-6989586621679083221"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679083221"><span class="hs-identifier hs-var">p</span></a></span></span><span> </span><span id="local-6989586621679083220"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679083220"><span class="hs-identifier hs-var">n</span></a></span></span><span> </span><span class="annot"><span class="annottext">Maybe Case
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679083221"><span class="hs-identifier hs-var">p</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679083220"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-69"></span><span>      </span><span class="annot"><span class="annottext">Case
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">let</span><span> </span><span class="annot"><a href="Features.Nominal.html#Poss"><span class="hs-identifier hs-type">Poss</span></a></span><span> </span><span id="local-6989586621679083218"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679083218"><span class="hs-identifier hs-var">p</span></a></span></span><span> </span><span id="local-6989586621679083217"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679083217"><span class="hs-identifier hs-var">n</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Possessive
</span><a href="Features.Nominal.html#possessive"><span class="hs-identifier hs-var hs-var">possessive</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083228"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679083218"><span class="hs-identifier hs-var">p</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679083217"><span class="hs-identifier hs-var">n</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-70"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier hs-var">possessiveHint</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-type">L</span></a></span><span> </span><span id="local-6989586621679083215"><span class="annot"><span class="annottext">[String]
</span><a href="#local-6989586621679083215"><span class="hs-identifier hs-var">tags</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.html#N"><span class="hs-identifier hs-type">N</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Noun.html#Noun"><span class="hs-identifier hs-type">Noun</span></a></span><span> </span><span id="local-6989586621679083213"><span class="annot"><span class="annottext">Noun
</span><a href="#local-6989586621679083213"><span class="hs-identifier hs-var">n</span></a></span></span><span class="hs-special">)</span><span> </span><span id="local-6989586621679083212"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083212"><span class="hs-identifier hs-var">nf</span></a></span></span><span class="hs-special">)</span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679083211"><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083211"><span class="hs-identifier hs-var">xs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot; (&quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">Noun -&gt; String
</span><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier hs-var">getNoun</span></a></span><span> </span><span class="annot"><span class="annottext">Noun
</span><a href="#local-6989586621679083213"><span class="hs-identifier hs-var">n</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;)&quot;</span></span><span>
</span><span id="line-71"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier hs-var">possessiveHint</span></a></span><span> </span><span class="hs-special">(</span><span id="local-6989586621679083209"><span class="annot"><span class="annottext">Maybe Constituent
</span><a href="#local-6989586621679083209"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679083208"><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083208"><span class="hs-identifier hs-var">xs</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Hint
</span><a href="Exercises.ItemWithAnswer.html#possessiveHint"><span class="hs-identifier hs-var">possessiveHint</span></a></span><span> </span><span class="annot"><span class="annottext">[Maybe Constituent]
</span><a href="#local-6989586621679083208"><span class="hs-identifier hs-var">xs</span></a></span><span>
</span><span id="line-72"></span><span>
</span><span id="line-73"></span><span class="hs-comment">-- | Given a constituent, create its corresponding FillGap constituent</span><span>
</span><span id="line-74"></span><span class="annot"><a href="Exercises.ItemWithAnswer.html#createGap"><span class="hs-identifier hs-type">createGap</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-75"></span><span>  </span><span class="hs-comment">-- | The constituent that will be replaced by a gap</span><span>
</span><span id="line-76"></span><span>  </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-comment">-- | The FillGap constituent</span><span>
</span><span id="line-78"></span><span>  </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-79"></span><span id="createGap"><span class="annot"><span class="annottext">createGap :: Constituent -&gt; Constituent
</span><a href="Exercises.ItemWithAnswer.html#createGap"><span class="hs-identifier hs-var hs-var">createGap</span></a></span></span><span> </span><span id="local-6989586621679083207"><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083207"><span class="hs-identifier hs-var">c</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-80"></span><span>  </span><span class="hs-keyword">if</span><span> </span><span class="annot"><span class="annottext">Constituent -&gt; Either EuskeraAppError String
</span><a href="Syntax.Constituent.html#instantiate"><span class="hs-identifier hs-var">instantiate</span></a></span><span> </span><span class="annot"><span class="annottext">Constituent
</span><a href="#local-6989586621679083207"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">Either EuskeraAppError String
-&gt; Either EuskeraAppError String -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; Either EuskeraAppError String
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-81"></span><span>    </span><span class="hs-keyword">then</span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Constituent
</span><a href="Syntax.Constituent.html#FillGap"><span class="hs-identifier hs-var">FillGap</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">False</span></span><span>
</span><span id="line-82"></span><span>    </span><span class="hs-keyword">else</span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Constituent
</span><a href="Syntax.Constituent.html#FillGap"><span class="hs-identifier hs-var">FillGap</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">True</span></span><span>
</span><span id="line-83"></span></pre></body></html>